/*
 * $Id$
 *
 * Copyright  2003 Eric Anholt
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Eric Anholt not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Eric Anholt makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * ERIC ANHOLT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL ERIC ANHOLT BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
/* $Header$ */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include "ati.h"
#include "klinux.h"

extern struct pci_id_list radeon_id_list[];
extern struct pci_id_list r128_id_list[];

void
InitCard(char *name)
{
	KdCardAttr attr;
	int i, j;

	for (i = 0; radeon_id_list[i].name != NULL; i++) {
		CARD16 vendor = radeon_id_list[i].vendor;
		CARD16 device = radeon_id_list[i].device;

		j = 0;
		while (LinuxFindPci(vendor, device, j++, &attr))
			KdCardInfoAdd(&ATIFuncs, &attr, 0);
	}

	for (i = 0; r128_id_list[i].name != NULL; i++) {
		CARD16 vendor = r128_id_list[i].vendor;
		CARD16 device = r128_id_list[i].device;

		j = 0;
		while (LinuxFindPci(vendor, device, j++, &attr))
			KdCardInfoAdd(&ATIFuncs, &attr, 0);
	}
}

void
InitOutput(ScreenInfo *pScreenInfo, int argc, char **argv)
{
	KdInitOutput(pScreenInfo, argc, argv);
}

void
InitInput(int argc, char **argv)
{
	KdInitInput(&LinuxMouseFuncs, &LinuxKeyboardFuncs);
}

void
ddxUseMsg (void)
{
	KdUseMsg();
	vesaUseMsg();
}

int
ddxProcessArgument(int argc, char **argv, int i)
{
	int	ret;
    
	if (!(ret = vesaProcessArgument (argc, argv, i)))
		ret = KdProcessArgument(argc, argv, i);
	return ret;
}
